CC=g++
CFLAGS=-s -Wall -ansi -pedantic -DNDEBUG
OFLAGS0=-O0
OFLAGS1=-O1
OFLAGS2=-O2
OFLAGS3=-O3
OFLAGS3ffG4=-O3 -fast -ffast-math -mcpu=7450 -mtune=G4
OFLAGS3ffG5=-O3 -fast -ffast-math -mtune=G5
OFLAGS3ffi686=-O3 -ffast-math -mcpu=i686 -mtune=i686
ARCHG4=G4
ARCHG5=G5
ARCHi686=i686
LD=g++
LFLAGS=

#lignes ci-dessous a modifier !!!
OFLAGS3ff=$(OFLAGS3ffG4)
ARCH=$(ARCHG4)
COMPILER_VERSION=gcc-4.0

all: Timer.o main-O0.o main-O1.o main-O2.o main-O3.o main-O3ff.o
	$(LD) $(LFLAGS) -o test-fastmath-O0 Timer.o main-O0.o
	$(LD) $(LFLAGS) -o test-fastmath-O1 Timer.o main-O1.o
	$(LD) $(LFLAGS) -o test-fastmath-O2 Timer.o main-O2.o
	$(LD) $(LFLAGS) -o test-fastmath-O3 Timer.o main-O3.o
	$(LD) $(LFLAGS) -o test-fastmath-O3ff Timer.o main-O3ff.o

main-O0.o: main.cpp Timer.h FastMath.h
	$(CC) $(CFLAGS) $(OFLAGS0) -o $@ -c $<

main-O1.o: main.cpp Timer.h FastMath.h
	$(CC) $(CFLAGS) $(OFLAGS1) -o $@ -c $<

main-O2.o: main.cpp Timer.h FastMath.h
	$(CC) $(CFLAGS) $(OFLAGS2) -o $@ -c $<

main-O3.o: main.cpp Timer.h FastMath.h
	$(CC) $(CFLAGS) $(OFLAGS3) -o $@ -c $<

main-O3ff.o: main.cpp Timer.h FastMath.h
	$(CC) $(CFLAGS) $(OFLAGS3ff) -o $@ -c $<

Timer.o:Timer.cpp Timer.h
	$(CC) $(CFLAGS) -o $@ -c $<

test:
	./test-fastmath-O0 results-$(COMPILER_VERSION)-$(ARCH)-O0.out
	./test-fastmath-O1 results-$(COMPILER_VERSION)-$(ARCH)-O1.out
	./test-fastmath-O2 results-$(COMPILER_VERSION)-$(ARCH)-O2.out
	./test-fastmath-O3 results-$(COMPILER_VERSION)-$(ARCH)-O3.out
	./test-fastmath-O3ff results-$(COMPILER_VERSION)-$(ARCH)-O3ff.out

clean:
	rm -f main-O0.o main-O1.o main-O2.o main-O3.o main-O3ff.o Timer.o test-fastmath-O0 test-fastmath-O1 test-fastmath-02 test-fastmath-O3 test-fastmath-O3ff
